searchData={"items":[{"type":"module","title":"AshAuthentication.Firebase","doc":"Firebase token authentication strategy for AshAuthentication.","ref":"AshAuthentication.Firebase.html"},{"type":"function","title":"AshAuthentication.Firebase.start/2","doc":"","ref":"AshAuthentication.Firebase.html#start/2"},{"type":"module","title":"AshAuthentication.Firebase.TokenVerifier","doc":"Verifies Firebase ID tokens using Google's public keys.\nImplements all security checks as per Firebase Auth documentation.","ref":"AshAuthentication.Firebase.TokenVerifier.html"},{"type":"function","title":"AshAuthentication.Firebase.TokenVerifier.verify/2","doc":"","ref":"AshAuthentication.Firebase.TokenVerifier.html#verify/2"},{"type":"module","title":"AshAuthentication.Firebase.TokenVerifier.KeyStore","doc":"GenServer responsible for managing Firebase public keys.\nFetches and caches JWKs (JSON Web Keys) from Google's servers.","ref":"AshAuthentication.Firebase.TokenVerifier.KeyStore.html"},{"type":"function","title":"AshAuthentication.Firebase.TokenVerifier.KeyStore.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"AshAuthentication.Firebase.TokenVerifier.KeyStore.html#child_spec/1"},{"type":"function","title":"AshAuthentication.Firebase.TokenVerifier.KeyStore.get_keys/0","doc":"","ref":"AshAuthentication.Firebase.TokenVerifier.KeyStore.html#get_keys/0"},{"type":"function","title":"AshAuthentication.Firebase.TokenVerifier.KeyStore.refresh_keys/0","doc":"","ref":"AshAuthentication.Firebase.TokenVerifier.KeyStore.html#refresh_keys/0"},{"type":"function","title":"AshAuthentication.Firebase.TokenVerifier.KeyStore.start_link/1","doc":"","ref":"AshAuthentication.Firebase.TokenVerifier.KeyStore.html#start_link/1"},{"type":"module","title":"AshAuthentication.Strategy.Firebase","doc":"AshAuthentication strategy for signing in with Firebase token.","ref":"AshAuthentication.Strategy.Firebase.html"},{"type":"function","title":"AshAuthentication.Strategy.Firebase.transform/2","doc":"","ref":"AshAuthentication.Strategy.Firebase.html#transform/2"},{"type":"function","title":"AshAuthentication.Strategy.Firebase.verify/2","doc":"","ref":"AshAuthentication.Strategy.Firebase.html#verify/2"},{"type":"module","title":"AshAuthentication.Strategy.Firebase.Dsl","doc":"DSL declaration for firebase strategies.","ref":"AshAuthentication.Strategy.Firebase.Dsl.html"},{"type":"function","title":"AshAuthentication.Strategy.Firebase.Dsl.dsl/0","doc":"","ref":"AshAuthentication.Strategy.Firebase.Dsl.html#dsl/0"},{"type":"module","title":"AshAuthentication.Strategy.Firebase.Transformer","doc":"DSL transformer for firebase strategies.","ref":"AshAuthentication.Strategy.Firebase.Transformer.html"},{"type":"function","title":"AshAuthentication.Strategy.Firebase.Transformer.transform/2","doc":"","ref":"AshAuthentication.Strategy.Firebase.Transformer.html#transform/2"},{"type":"module","title":"AshAuthentication.Strategy.Firebase.Verifier","doc":"DSL verifier for firebase strategies.","ref":"AshAuthentication.Strategy.Firebase.Verifier.html"},{"type":"function","title":"AshAuthentication.Strategy.Firebase.Verifier.verify/2","doc":"","ref":"AshAuthentication.Strategy.Firebase.Verifier.html#verify/2"},{"type":"extras","title":"AshAuthentication.Firebase","doc":"# AshAuthentication.Firebase\n\n[![Hex.pm](https://img.shields.io/hexpm/v/ash_authentication_firebase.svg?style=flat-square)](https://hex.pm/packages/ash_authentication_firebase)\n[![Hex.pm](https://img.shields.io/hexpm/dt/ash_authentication_firebase.svg?style=flat-square)](https://hex.pm/packages/ash_authentication_firebase)\n\nFirebase token authentication strategy for [AshAuthentication](https://github.com/team-alembic/ash_authentication).\n\n> 🛠 In development. Use at your own risk.","ref":"readme.html"},{"type":"extras","title":"Installation - AshAuthentication.Firebase","doc":"The package can be installed by adding `ash_authentication_firebase` to your list of dependencies in mix.exs:\n\n```elixir\ndef deps do\n  [\n    {:ash_authentication_firebase, \"~> 0.2.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - AshAuthentication.Firebase","doc":"Please consult with official [Ash documentation](https://ash-hq.org/docs/guides/ash_authentication/latest/tutorials/getting-started-with-authentication) on how to create your resource.\n\nAdd `AshAuthentication.Strategy.Firebase` to your resource `extensions` list and `:firebase` strategy to the `authentication` section:\n\n```elixir\ndefmodule MyApp.Accounts.User do\n  use Ash.Resource,\n    extensions: [AshAuthentication, AshAuthentication.Strategy.Firebase]\n\n...\n\n  authentication do\n    api MyApp.Accounts\n\n    strategies do\n      # You can have multiple firebase strategies\n      firebase :firebase do\n        project_id \"project-123abc\"\n        token_input :firebase_token\n      end\n    end\n  end\n...\n\nend\n```","ref":"readme.html#usage"},{"type":"extras","title":"Secrets and Runtime Configuration - AshAuthentication.Firebase","doc":"To avoid hardcoding your Firebase project id in your source code, you can use the `AshAuthentication.Secret` behaviour. This allows you to provide the project id through runtime configuration using either an anonymous function or a module.","ref":"readme.html#secrets-and-runtime-configuration"},{"type":"extras","title":"Examples: - AshAuthentication.Firebase","doc":"Using an anonymous function:\n\n```elixir\nauthentication do\n  strategies do\n    firebase :firebase do\n      project_id fn _path, _resource ->\n        Application.fetch_env(:my_app, :firebase_project_id)\n      end\n      token_input :firebase_token\n    end\n  end\nend\n```\n\nUsing a module:\n\n```elixir\ndefmodule MyApp.Secrets do\n  use AshAuthentication.Secret\n\n  def secret_for([:authentication, :strategies, :firebase, :project_id], MyApp.User, _opts) do\n    Application.fetch_env(:my_app, :firebase_project_id)\n  end\nend\n\n# And in your resource:\n\nauthentication do\n  strategies do\n    firebase :firebase do\n      project_id MyApp.Secrets\n      token_input :firebase_token\n    end\n  end\nend\n```","ref":"readme.html#examples"},{"type":"extras","title":"Acknowledgements - AshAuthentication.Firebase","doc":"Inspired by [ExFirebaseAuth](https://github.com/Nickforall/ExFirebaseAuth).","ref":"readme.html#acknowledgements"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}